;; open X86

(* The generated factorial program doesn't obey cdecl calling conventions. *)

let fact_non_cdecl_blocks = [
  mk_block "fact" [
    Cmp(eax, Imm 1l);
    J(Sgt, mk_lbl_named "else_branch");
    Mov(eax, Imm 1l);
    Ret;
  ];
  mk_block "else_branch" [
    Push(eax);
    Sub(eax, Imm 1l);
    Call(Lbl (mk_lbl_named "fact"));
    Pop(edx);
    Imul(Eax, edx);
    Ret;
  ]
]

(* On unix/linux/Mac gcc uses _ to munge names *)
let fact_main_block = {
  global = true;  (* Make this block visible to the linker *)
  label = mk_lbl_named "_program";
  insns = [
    Mov(eax, Imm 5l);
    Call(Lbl (mk_lbl_named "fact"));
    Ret;
  ];
}


let program = 
  List.map (fun x -> Cunit.Code x) (fact_main_block::fact_non_cdecl_blocks)


let _ = Cunit.output_cunit program stdout
