;; open X86


let ebp_offset (amt:int32) : opnd = 
  Ind {
    i_base = Some Ebp;
    i_iscl = None;
    i_disp = Some (DImm amt)
  }

let square_block = mk_block "square" [
  Mov(eax, stack_offset 4l);
  Imul(Eax, eax);
  Ret;
]



let f_block = mk_block "f" [
    Push(ebp);
    Mov(ebp, esp);
    
    Mov(eax, ebp_offset 12l);
    Mov(ebx, ebp_offset 8l);
    Sub(eax, ebx);

    Push(eax);
    Call(Lbl (mk_lbl_named "square"));
    Add(esp, i32 4l);
    
    Pop(ebp);
    Ret;
]


let program_block = {
  global = true;
  label = mk_lbl_named "_program";
  insns = [
    Push(ebp);
    Mov(ebp, esp);

    Push(i32 10l);
    Push(i32 5l);
    Call(Lbl (mk_lbl_named "f"));
    Add(esp, i32 8l);
    
    Pop(ebp);
    Ret;
  ]
}



let program =
  List.map (fun x -> Cunit.Code x) [program_block; f_block; square_block]

let _ = Cunit.output_cunit program stdout
